<?php
if(!class_exists("Gc_Message_Box_Renderer")){
    class Gc_Message_Box_Renderer extends Gc_Abstract_Renderer{
        protected $options;

        public function __construct($namespace, $controller){
            parent::__construct($namespace,$controller);
    	}

    	public function render($gci){
            echo "<div class=\"gc_message_box\" id='gci_".$gci."' style='".$this->get_style()."'>".
            $this->render_inner_content().
            "</div>";

    	}

        protected function get_general_options(){
            return $this->options->filter_options_by_group("general");
        }

        protected function get_style_options(){
            return $this->options->filter_options_by_group("style");
        }


        protected function render_inner_content() {
            $align = $this->get_option_value('content_layout');
            $align_renderer = new Gc_Message_Box_Align_Renderer($align, $this);
            return $align_renderer->render();
        }
        
        protected function get_style() {
            $style = "";
            //Margins
            if ($this->controller->is_list()) {
                $style .= "margin-top: " . $this->get_option_value('margin_top_list') . "px; ";
                $style .= "margin-right: " . $this->get_option_value('margin_right_list') . "px; ";
                $style .= "margin-bottom: " . $this->get_option_value('margin_bottom_list') . "px; ";
                $style .= "margin-left: " . $this->get_option_value('margin_left_list') . "px; ";
            }
            if ($this->controller->is_page()) {
                $style .= "margin-top: " . $this->get_option_value('margin_top_page') . "px; ";
                $style .= "margin-right: " . $this->get_option_value('margin_right_page') . "px; ";
                $style .= "margin-bottom: " . $this->get_option_value('margin_bottom_page') . "px; ";
                $style .= "margin-left: " . $this->get_option_value('margin_left_page') . "px; ";
            }
            //Padding
            $style .= "padding: 12px; ";
            return $style;
        }
        
        public function render_message() {
            $message = "<span id=\"".$this->namespace."message\">".$this->get_option_value('message_text')."</span>";
            return $message;
        }
        
        public function render_button($class = null) {
            $message = $this->get_option_value('action_button_text');
            if (empty($message)) {
                return;
            }
            $content = "";
            if ($this->get_option('action_target')->is_checked()) {
                $content = "<a target=\"_blank\" ";
            } else {
                $content = "<a target=\"_top\" ";
            }
            $content .= "class=\"".$this->namespace.$class."\" href=".$this->get_option_value('action_url').">";
            $content .= "<span id=\"".$this->namespace."button\">";
            $content .= "<span id=\"".$this->namespace."buttontext\">".$this->get_option_value('action_button_text');
            $content .= "</span></span></a>";
            return $content;
        }
        
    }
}